#! /usr/local/bin/perl
#############################################################################
#  
#   File:          PostMessage.pl
#
#   Author:        Jungmin Kim
#
#   Created:       03/05/95 
#   Modified:      
#   Version: 
#
#   Input:         path name, file name, 
#                  title, message, (current message for feed back)
#                  hidden date, hidden name, hidden title, hidden message
#                  ( message to be responded ),
#                  user information
#   Output:        HTML text with fill-out forms
#          
#
#   Description:   Create fill-out forms to edit message.
#                  passed message (to be responded), and made message are
#                  passed to main function.
#                  passed message: path/filename
#                  new message:    path/(new file)
#               
#   Usage:         "http://.../Action.pl/post:path:file:user"
#                  user should be changed to "username:email_address".
#
#
#############################################################################

sub PostMessage{
    local($path, $file, $title, $message, 
	  $hdate, $hname,  $htitle, $hmessage, $method, $user,
	  $initial, $hdate2, $hname2,  $htitle2, $hmessage2,
	  $subdir) = @_;

    # ****************************************************** modified
    local($pname, $pemail, $html_title, $html_message, 
	  $html_title2, $html_message2, $temp, $temp2,
	  $response, $comment, $newpost, $pathname );

    if ($method eq "" || $method eq "response") {
	$response = "CHECKED";
	$comment = $newpost = "";
    }
    elsif ($method eq "comment") {
	$comment = "CHECKED";
	$response = $newpost = "";
    }
    else {
	$newpost = "CHECKED";
	$response = $comment = "";
    }

    $html_title = $htitle;
    $html_message = $hmessage;
    $html_title2 = $htitle2;
    $html_message2 = $hmessage2;

    $temp = $html_title;	# original title of message to be responded
    $temp =~ s/\<P\>/ /ig;
    $temp =~ s/\<BR\>/ /ig;
    $temp2 = $html_title2;		
    $temp2 =~ s/\<P\>/ /ig;
    $temp2 =~ s/\<BR\>/ /ig;

    #### replace HTML reserved characters
    $htitle =~ s/&/&amp;/g;
    $htitle =~ s/>/&gt;/g;
    $htitle =~ s/</&lt;/g;
    $htitle =~ s/\"/&quot;/g;
    $hmessage =~ s/&/&amp;/g;
    $hmessage =~ s/>/&gt;/g;
    $hmessage =~ s/</&lt;/g;
    $hmessage =~ s/\"/&quot;/g;
    $htitle2 =~ s/&/&amp;/g;
    $htitle2 =~ s/>/&gt;/g;
    $htitle2 =~ s/</&lt;/g;
    $htitle2 =~ s/\"/&quot;/g;
    $hmessage2 =~ s/&/&amp;/g;
    $hmessage2 =~ s/>/&gt;/g;
    $hmessage2 =~ s/</&lt;/g;
    $hmessage2 =~ s/\"/&quot;/g;
    $title =~ s/&/&amp;/g;
    $title =~ s/>/&gt;/g;
    $title =~ s/</&lt;/g;
    $title =~ s/\"/&quot;/g;
    $message =~ s/&/&amp;/g;
    $message =~ s/>/&gt;/g;
    $message =~ s/</&lt;/g;
    $message =~ s/\"/&quot;/g;

# THIS COULD BE A BUG -- use different delimiter (other than colon)?
# It's currently not used is OK for the moment. (PDC)
    #### decode user information to get email address
    $_ = $user;
    s/\+/ /g;    ### Is this OK, or a BUG??
    ($pname, $pemail) = split(/:/, $_);

    print "Content-type\: text/html\n\n";
    print "\n";
    print "<TITLE> POST MESSAGE </TITLE>\n";
    print "<H1> Post a message </H1>\n";

    $pathname = $conference{$path};
    print "<H2> to ${pathname} forum</H2>";
    print "<HR>\n";
    print "<B>RESPONDING TO MESSAGE\:</B> ";
    print "$file. <A HREF=\"#$file\">$temp</A><BR>\n";
    if ($file ne $initial) {
      print "<B>INITIAL MESSAGE ON THIS SUBJECT:</B> ";
      print "$initial. <A HREF=\"#$initial\">$temp2</A><BR>\n";
      print "<i>(Messages are appended at the bottom of the page)</i>\n";
    }
    else {
      print "<i>(Message is appended at the bottom of the page)</i>\n";
    }
    print "<P>\n";
    print "<IMG SRC=\"$gif/pointer.xbm\" ALIGN=\"left\" ALT=\"\">";
    print "<B><A HREF=\"$action/$subdir\:read\:$path\:$file\:$user#$file\">\n";
    print "CANCEL this post and return to the forum</A></B>\n";
    print "<HR>\n";

    print "<P>\n";
    print "<FORM METHOD=\"POST\" ";
    print "ACTION=\"$action\/$subdir\:preview\:$path\:$file\:$user\">\n";
    print "<DL><DT><B>Choose one of the following</B>\:\n";
    print "<DD>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"method\" VALUE=\"response\" $response>\n";
    print "<i> Add a response concerning this topic </i><BR>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"method\" VALUE=\"comment\" $comment>\n";
    print "<i> Add a comment specific to this particular message </i><BR>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"method\" VALUE=\"newpost\" $newpost>\n";
    print "<i> Post a new independent message</i><BR>\n";
    print "</DL>\n";

    #### hidden fields to be passed

    print "<INPUT TYPE=\"hidden\" NAME=\"hdate\" VALUE=\"$hdate\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"hname\" VALUE=\"$hname\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"htitle\" VALUE=\"$htitle\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"hmessage\" VALUE=\"$hmessage\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"hdate2\" VALUE=\"$hdate2\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"hname2\" VALUE=\"$hname2\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"htitle2\" VALUE=\"$htitle2\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"hmessage2\" VALUE=\"$hmessage2\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"initial\" VALUE=\"$initial\">\n";


    #### generate fill-out forms
    
    print "<P>\n";
    print "<BR>\n";
    print "<B>Type in a subject title for your message\: </B><BR>\n";
    print "<TEXTAREA NAME=\"title\" ROWS=2 COLS=60>${title}</TEXTAREA><P>\n";
    print "<B>Type in your message\: </B><BR> ";
    print "<TEXTAREA NAME=\"message\" ROWS=20 COLS=60>${message}</TEXTAREA> <P>\n";

    print "<INPUT TYPE=\"submit\" VALUE=\"SUBMIT\">\n";
    print "<B>Press this button to preview and submit your message.</B><P>\n";

    print "</FORM>";

    #### Include the message you're replying to

    print "<P><HR>\n";
    print "<A NAME=\"$file\">\n";
    print "<H3>You are responding to the following message\: </H3>\n";
    print "$file From <I><B>$hname</B></I>\n";
    print "on $hdate\n";
    print "regarding <B>$html_title</B>\n";
    print "<P>\n";
    print "$html_message\n";
    print "<P>\n";

    #### Include the initial message 

    if ($file ne $initial) {
      print "<P><HR>\n";
      print "<A NAME=\"$initial\">\n";
      print "<H3>The initial message on this subject\: </H3>\n";
      print "$initial From <I><B>$hname2</B></I>\n";
      print "on $hdate2\n";
      print "regarding <B>$html_title2</B>\n";
      print "<P>\n";
      print "$html_message2\n";
      print "<P>\n";
    }
}
1;
