#! /usr/local/bin/perl
#############################################################################
#  
#   File:          PreviewMessage.pl
#
#   Author:        Jungmin Kim and Paul Coddington (paulc@npac.syr.edu)
#
#   Created:       03/05/95
#   Modified:      
#   Version: 
#
#   Input:         path name, file name,
#                  title, message (current message)
#                  hidden date, hidden name, hidden title, hidden message
#                  (message to be responded)
#                  user information
#   Output:        HTML text
#          
#
#   Description:   Print out the message entered to preview the message 
#                  before post it. both of current message and the 
#                  message to be responded are passed to main function
#               
#   Usage:         "http://.../Action.pl/preview:path:file:user"
#                  user should be "username:email_address".
#
#
#############################################################################

sub PreviewMessage{
    local($path, $file, $title, $message, 
	  $hdate, $hname,  $htitle, $hmessage, $method, $user,
	  $initial, $hdate2, $hname2, $htitle2, $hmessage2,
	  $subdir) = @_;

    local ($temp, $temp2, $tmpuser, $html_message, $html_title);

    $temp = $htitle;		# original title of message to be responded
    $temp =~ s/\<P\>/ /ig;
    $temp =~ s/\<BR\>/ /ig;
    $temp2 = $htitle2;		
    $temp2 =~ s/\<P\>/ /ig;
    $temp2 =~ s/\<BR\>/ /ig;

    #### save message and titel to modify them
    $html_message = $message;
    $html_title = $title;

    #### replace HTML reserved characters
    $htitle =~ s/&/&amp;/g;
    $htitle =~ s/>/&gt;/g;
    $htitle =~ s/</&lt;/g;
    $htitle =~ s/\"/&quot;/g;
    $hmessage =~ s/&/&amp;/g;
    $hmessage =~ s/>/&gt;/g;
    $hmessage =~ s/</&lt;/g;
    $hmessage =~ s/\"/&quot;/g;
    $htitle2 =~ s/&/&amp;/g;
    $htitle2 =~ s/>/&gt;/g;
    $htitle2 =~ s/</&lt;/g;
    $htitle2 =~ s/\"/&quot;/g;
    $hmessage2 =~ s/&/&amp;/g;
    $hmessage2 =~ s/>/&gt;/g;
    $hmessage2 =~ s/</&lt;/g;
    $hmessage2 =~ s/\"/&quot;/g;
    $title =~ s/&/&amp;/g;
    $title =~ s/>/&gt;/g;
    $title =~ s/</&lt;/g;
    $title =~ s/\"/&quot;/g;
    $title =~ s/&/&amp;/g;
    $message =~ s/&/&amp;/g;
    $message =~ s/>/&gt;/g;
    $message =~ s/</&lt;/g;
    $message =~ s/\"/&quot;/g;
    $message =~ s/&/&amp;/g;
    
    $tmpuser = $user;
    $tmpuser =~ s/\+/ /g;
    ($username, $userid) = split(/\:/, $tmpuser);

    # *******************************************************************

    print "Content-type\: text/html\n\n";
    print "\n";
    print "<TITLE> PREVIEW MESSAGE </TITLE>\n";
    print "<H1> Preview your message </H1>\n";

    # ********************************************************* modified
    $pathname = $conference{$path};
    print "<H2>to $pathname forum</H2>\n";
    # ********************************************************* modified

    print "<HR>\n";
    print "<IMG SRC=\"$gif/pointer.xbm\" ALIGN=\"left\" ALT=\"\">";
    print "<B><A HREF=\"$action\/$subdir\:read\:$path\:$file\:$user#$file\">\n";
    print "CANCEL this post and return to the forum</A></B>\n";
    print "<P>\n";
    if($method eq "response") {
        print "<B>RESPONDING TO MESSAGE\:</B> $initial. $temp2";
    }
    elsif($method eq "comment") {
        print "<B>RESPONDING TO MESSAGE\:</B> $file. $temp";
    }
    else {
	print "<B>POSTING A NEW INDEPENDENT MESSAGE</B>\n";
    }

    print "<HR>\n";

    #### replace all double CR and LF characters with <P>
    $html_title =~ s/(\r\n\r\n|\n\n|\r\r)/\<P\>\n/g;
    $html_message =~ s/(\r\n\r\n|\n\n|\r\r)/\<P\>\n/g;

    # ***************************************************** modified
    print "<B> YOUR MESSAGE IS: </B><P>\n";
    print "<B>From\: </B> $username <I>($userid)</I>\n";
    print "<P><B>Subject\: </B> $html_title \n";
    print "<P><B>Message\: </B><P>\n";
    print "$html_message <P>\n";
    
    # **************************************************************
   
    print "<HR>\n";
    print "<P>\n";

    print "<FORM METHOD=\"POST\" ";
    print "ACTION=\"$action\/$subdir\:postit\:$path\:$file\:$user\">\n";
    print "<DL><DT><B>Choose one of the following</B>\:\n";
    print "<DD>\n";
    print "<I>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"edit\" VALUE=\"no\" CHECKED>\n";
    print " Post the message<BR>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"edit\" VALUE=\"yes\">\n";
    print " Edit the message <BR>\n";
    print "</I></DL>\n";

    #### hidden fields
    print "<INPUT TYPE=\"hidden\" NAME=\"hdate\" VALUE=\"$hdate\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"hname\" VALUE=\"$hname\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"htitle\" VALUE=\"$htitle\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"hmessage\" VALUE=\"$hmessage\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"hdate2\" VALUE=\"$hdate2\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"hname2\" VALUE=\"$hname2\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"htitle2\" VALUE=\"$htitle2\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"hmessage2\" VALUE=\"$hmessage2\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"initial\" VALUE=\"$initial\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"title\" VALUE=\"$title\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"message\" VALUE=\"$message\">\n";
    print "<INPUT TYPE=\"hidden\" NAME=\"method\" VALUE=\"$method\">\n";

    print "<INPUT TYPE=\"submit\" VALUE=\"SUBMIT\">\n";
    print "<B>\n";
    print " Press this button to post or edit your message. \n";
    print "</B>\n";
    print "</FORM>\n";

    print "<P><HR><p>\n";

}
1;

