#! /usr/local/bin/perl
#############################################################################
#  
#   File: SelectBoard.pl 
#
#   Author:        Jungmin Kim
#
#   Created:       March 5  1995
#   Modified:      March 23 1995 by Paul Coddington 
#   Version: 
#
#   Input:         username
#   Output:        HTML text
#          
#
#   Description:   Print out HTML page of index of conferences 
#               
#   Usage:         "http://.../Action.pl/select:(NULL):(NULL):user"
#                  'user' should be "username:email_address".
#
#############################################################################

sub SelectBoard {
    local($user, $subdir) = @_;		      # user information
    local($key);

    print "Content-type\: text/html\n\n";
    print "\n";
    print "<TITLE> WeBBoard Forum Index </TITLE>\n";

    # Open file containing the title of this version of WeBBoard
    $titlefile = "$webboardhome/$subdir/$check/title.html";
    if ( open(INFILE, "< $titlefile") ) {
      while (<INFILE>) {
        $title = $_;
      }
      print "<H2> WeBBoard Forums for </H2>\n";
      print "<H1> $title </H1>\n";
    }
    else {
      print "<H2> WeBBoard Forums </H2>\n";
    }

    print "<BR>\n";
    print "<H3> Select a forum from the index below\: </H3>\n";
    print "<HR>\n";
    print "<H3>\n";
    print "<UL>\n";

    foreach $key (sort keys %conference) {
	if ($key eq "") { next;}
	print "<LI>\n";
	if ($subdir eq "") {
	    print "<A HREF=\"${action}\/$key\:select\:\:\:${user}\">";
	    print " $conference{$key} </A><p>\n";
	}
	else {
	    print "<A HREF=\"${action}\/$subdir\:read\:$key\:\:$user\">";
	    print " $conference{$key} </A><P>\n";
	}
    }

    print "</UL>\n";
    print "</H3>\n";
    print "<HR>\n";


    ### if user name is administrator, print out options to change configuration

    if($user =~/^administrator\:/) {

    print "Choose one of the following to change configuration\n";
    print "<DL><DD>\n";
    print "<B>\n";
    print "<FORM METHOD=\"POST\" ACTION=\"$change\/$subdir\:\:${user}\">\n";
    print "<INPUT TYPE=\"radio\" NAME=\"subject\" VALUE=\"addconf\"\n";
    print " CHECKED>\n";
    print " Add a new forum<BR>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"subject\" VALUE=\"delconf\">\n";
    print " Delete a forum<BR>\n";
    print "<INPUT TYPE=\"radio\" NAME=\"subject\" VALUE=\"option\">\n";
    print " Change preferences<BR>\n";
    if ($allow ne "yes") {
      print "<INPUT TYPE=\"radio\" NAME=\"subject\" VALUE=\"adduser\">\n";
      print " Add a new user name<BR>\n";
      print "<INPUT TYPE=\"radio\" NAME=\"subject\" VALUE=\"deluser\">\n";
      print " Delete a user name<BR>\n";
    }
    print "</B></DL>\n";
    print "<INPUT TYPE=\"submit\" VALUE=\"SUBMIT\">\n";
    print " Click on this button to submit your request. <P>\n";    
    print "<HR>\n";

    }

# Address and copyright
Address();
}
1;

